﻿<Graph ClassName="ARInvoiceEntryExtBOC" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using PX.Common;
using PX.Objects.Common;
using PX.Objects.Common.Discount;
using PX.Data;
using PX.Data.DependencyInjection;
using PX.LicensePolicy;
using PX.Objects.GL;
using PX.Objects.CM;
using PX.Objects.CS;
using PX.Objects.CR;
using PX.Objects.TX;
using PX.Objects.IN;
using PX.Objects.BQLConstants;
using PX.Objects.EP;
using PX.Objects.SO;
using PX.Objects.DR;
using SOInvoiceEntry = PX.Objects.SO.SOInvoiceEntry;
using CRLocation = PX.Objects.CR.Standalone.Location;
using PX.Objects.GL.Reclassification.UI;
using PX.Objects.AR.BQL;
using PX.Objects.Common.Extensions;
using PX.Objects.PM;
using System.Text;
using PX.Objects.Common.Bql; 
using PX.Objects.GL.FinPeriods;
using PX.Objects;
using PX.Objects.AR;

namespace PX.Objects.AR
{
    public class ARInvoiceEntryExtBOC : PXGraphExtension<ARInvoiceEntry>
    {
        #region Event Handlers
        protected void ARInvoice_RowSelected(PXCache cache, PXRowSelectedEventArgs e)
        {
            var row = (ARRegister)e.Row;
            if (row == null) return;

            var rowExt = PXCache<ARRegister>.GetExtension<ARRegisterExtBOC>(row);
            PXUIFieldAttribute.SetVisible<ARRegisterExtBOC.usrBOCRefNbr>(cache, row, rowExt.UsrBOCRefNbr != null);
        }

        protected void ARInvoice_UsrCounterDate_FieldUpdated(PXCache cache, PXFieldUpdatedEventArgs e)
        {
            var row = (ARInvoice)e.Row;
            if (row == null) return;

            DateTime? counterDueDate = BOCDueDate((ARInvoice)row);
            if (counterDueDate != null)
                cache.SetValueExt<ARInvoice.dueDate>(row, counterDueDate);
        }

        protected void ARInvoice_TermsID_FieldUpdated(PXCache cache, PXFieldUpdatedEventArgs e)
        {
            var row = (ARInvoice)e.Row;
            if (row == null) return;

            DateTime? counterDueDate = BOCDueDate(row);
            if (counterDueDate != null)
                cache.SetValueExt<ARInvoice.dueDate>(row, counterDueDate);
        }
        

        public DateTime? BOCDueDate(ARInvoice row)
        {
            var rowExt = PXCache<ARRegister>.GetExtension<ARRegisterExtBOC>(row);
            
            if (rowExt.UsrCounterDate != null)
            {
                BAccount customer = Base.customer.Current;
                if (customer != null)
                {
                    var customerExt = PXCache<BAccount>.GetExtension<BAccountExtBOC>(customer);

                    if (customerExt.UsrComputeDueDateOnCounterDate == true)
                    {
                        Terms terms = PXSelect<
                            Terms,
                            Where<Terms.termsID, Equal<Current<ARInvoice.termsID>>>>
                            .Select(Base);

                        if (terms != null)
                        {
                            DateTime newDueDate = ((DateTime)rowExt.UsrCounterDate).AddDays((double)terms.DayDue00);

                            return (DateTime?)newDueDate;
                        }
                    }
                }
            }

            return null;
        }
        #endregion
    }
}]]></CDATA>
</Graph>